const Lang = imports.lang;
const Applet = imports.ui.applet;
const GLib = imports.gi.GLib;
const Meta = imports.gi.Meta;
const Gettext = imports.gettext.domain('cinnamon-applets');
const _ = Gettext.gettext;

function MyApplet(orientation) {
    this._init(orientation);
}

MyApplet.prototype = {
    __proto__: Applet.IconApplet.prototype,

    _init: function(orientation) {        
        Applet.IconApplet.prototype._init.call(this, orientation);
        
        try {        
            this.set_applet_icon_symbolic_name("changes-prevent");
            this.set_applet_tooltip(_("Click to lock the screen immediately"));                                                
        }
        catch (e) {
            global.logError(e);
        }
    },
    
    on_applet_clicked: function(event) {
        GLib.spawn_command_line_async('gnome-screensaver-command --lock');
    }
   
};

function main(metadata, orientation) {  
    let myApplet = new MyApplet(orientation);
    Meta.keybindings_set_custom_handler('set-spew-mark', function() {
        GLib.spawn_command_line_async('gnome-screensaver-command --lock');
    });
    return myApplet;      
}
